﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TrabajoFinal
{
    class Administracion
    {
        public ArrayList cajeros;
        public ArrayList cajas;
        public ArrayList productos;
        public ArrayList promociones;
        public ArrayList compras;
        public Carro carroCompra;
        public int numeroCajas;

        public Administracion(int nCajas)
        {
            cajeros = new ArrayList();
            cajas = new ArrayList();
            productos = new ArrayList();
            promociones = new ArrayList();
            compras = new ArrayList();
            carroCompra = new Carro(new ArrayList(),new ArrayList());
            numeroCajas = nCajas;
        }

        public decimal TotalRecaudado(ArrayList c,int ultimo)
        {
            if (ultimo >= 0)
            {
                Compra cm = (Compra)c[ultimo];
                if (ultimo == 0)
                    return cm.total;
                else
                    return cm.total + TotalRecaudado(c, ultimo - 1);
            }
            else
                return 0;
        }
        public void TotalRecaudado(string nombre)
        {
            Console.WriteLine("\n\nTotal Recaudado en el supermercado '{0}': {1:0.00} pesos", nombre, TotalRecaudado(compras,compras.Count - 1));
        }

        public decimal TotalRecaudadoCajero(Cajero cj, ArrayList c, int ultimo)
        {
            if (ultimo >= 0)
            {
                Compra cm = (Compra)c[ultimo];
                if (cm.cajero == cj)
                {
                    if (ultimo == 0)
                        return cm.total;
                    else
                        return cm.total + TotalRecaudadoCajero(cj, c, ultimo - 1);
                }
                else
                    return TotalRecaudadoCajero(cj, c, ultimo - 1);
            }
            else
                return 0;
        }
        public void TotalRecaudadoCajero(string nombre)
        {
            Console.WriteLine("\n\nTotal Recaudado en el supermercado discriminado por cajero:");
            foreach(Cajero cj in cajeros)
                Console.WriteLine("{0} {1}: {2} pesos", cj.nombre, cj.apellido, TotalRecaudadoCajero(cj, compras, compras.Count - 1));
        }
        public decimal TotalRecaudadoCaja(Caja cj,ArrayList c, int ultimo)
        {
            if (ultimo >= 0)
            {
                Compra cm = (Compra)c[ultimo];
                if (cm.caja == cj)
                {
                    if (ultimo == 0)
                        return cm.total;
                    else
                        return cm.total + TotalRecaudadoCaja(cj, c, ultimo - 1);
                }
                else
                    return TotalRecaudadoCaja(cj, c, ultimo - 1);
            }
            else
                return 0;
        }
        public void TotalRecaudadoCaja(String nombre)
        {
            Console.WriteLine("\n\nTotal Recaudado en el supermercado discriminado por caja:");
            foreach (Caja cj in cajas)
                Console.WriteLine("Caja {0}: {1} pesos", cj.numero, TotalRecaudadoCaja(cj, compras, compras.Count - 1));
        }
        public void AltaCajas()
        {
            for(int i = 1; i <= numeroCajas; i++)
            {
                Caja caja = new Caja(i, null);
                cajas.Add(caja);
            }
        }

        public bool AltaCajero(string nombre, string apellido, int dni, string horario)
        {
            foreach (Cajero cajero in cajeros)
            {
                if (cajero.nombre == nombre && cajero.apellido == apellido && cajero.DNI == dni)
                    return false;
            }
            Cajero c = new Cajero(nombre, apellido, dni, horario);
            cajeros.Add(c);
            return true;
        }
        public bool EstadoCajero(int cajero)
        {
            Cajero c = (Cajero)cajeros[cajero - 1];

            foreach(Caja caja in cajas)
            {
                if (caja.cajero == c)
                    return false;
            }

            return true;
        }
        public string EstadoCajero(int cajero,bool e)
        {
            string imprimir = "";
            Cajero c = (Cajero)cajeros[cajero - 1];

            foreach (Caja caja in cajas)
            {
                if (caja.cajero == c)
                    imprimir = c.nombre + " " + c.apellido + " ya está trabajando en la caja " + caja.numero;
            }
            return imprimir;
        }
        public string CajaCajero(int num)
        {
            Caja c = (Caja)cajas[num - 1];

            return c.cajero.nombre + " " + c.cajero.apellido;
        }
        public void MostrarCajeros()
        {
            int i = 1;
            foreach (Cajero c in cajeros)
            {
                string[] elementos = c.horarioTrabajo.Split('-');
                TimeSpan h_entrada = new TimeSpan(int.Parse(elementos[0]), 0, 0);
                TimeSpan h_salida = new TimeSpan(int.Parse(elementos[1]), 0, 0);
                Console.WriteLine("{0}) {1} {2} - Horario de trabajo: {3} a {4}", i, c.nombre, c.apellido,h_entrada,h_salida);
                i++;
            }
        }

        public bool EstadoCaja(int num)
        {
            Caja c = (Caja)cajas[num - 1];
            return c.estado;
        }
        public bool CajasAbiertas()
        {
            bool estado = false;
            foreach(Caja c in cajas)
            {
                if (c.estado)
                {
                    Console.WriteLine("Caja {0} atendida por {1} {2}", c.numero, c.cajero.nombre, c.cajero.apellido);
                    estado = true;
                }
            }
            return estado;
        }
        public string CajasEstado(bool e)
        {
            string cs = "";

            foreach (Caja c in cajas)
            {
                if (e)
                {
                    if (c.estado)
                        cs += c.numero + ",";
                }
                else
                {
                    if (!c.estado)
                        cs += c.numero + ",";
                }
            }
            if (cs.Length > 0)
                cs = cs.Remove(cs.Length - 1);
            else
            {
                if (e)
                    cs = "Todas las cajas están cerradas";
                else
                    cs = "Todas las cajas están abiertas";
            }


            return cs;
        }
        public void MostrarCajas()
        {
            foreach (Caja c in cajas)
            {
                string texto = "Caja "+ String.Format("{0:00}", c.numero);
                if (c.estado)
                    texto += " atendida por " + c.cajero.nombre + " " + c.cajero.apellido;
                else
                    texto += " CERRADA";
                Console.WriteLine(texto);
            }
        }
        public void cerrarCaja(int num)
        {
            Caja c = (Caja)cajas[num - 1];
            c.cajero = null;
            c.estado = false;
        }
        public void AbrirCaja(Cajero cajero, Caja caja)
        {
            caja.cajero = cajero;
            caja.estado = true;
        }
        
        public bool AltaPromocion(int cantPr, int cantPa, Producto p)
        {
            foreach (Promocion promo in promociones)
            {
                if (promo.cantPaga == cantPa && promo.cantProducto == cantPr && promo.producto == p)
                    return false;
            }
            Promocion promocion = new Promocion(cantPr,cantPa,p);
            promociones.Add(promocion);

            return true;
        }
        public void MostrarPromociones()
        {
            int i = 1;
            foreach (Promocion p in promociones)
            {
                Console.WriteLine("{0}) {1} '{2}' ({3}) ==> {4}x{5}", i, p.producto.tipoProducto, p.producto.marca, p.producto.envase, p.cantProducto, p.cantPaga);
                i++;
            }
        }

        public void AgregarStock(int p, int cantidad)
        {
            Producto pr = (Producto)productos[p - 1];
            pr.cantidad += cantidad;
        }
        public bool AltaProducto(int cantidad, string tipoProducto, string marca, string envase, decimal precio, DateTime fecha) {
            foreach (Producto p in productos)
            {
                if (p.tipoProducto == tipoProducto && p.marca == marca && p.envase == envase)
                    return false;
            }
            Producto producto = new Producto(cantidad, tipoProducto, marca,envase,precio,fecha);
            productos.Add(producto);
            return true;
        }
        public int MostrarProductos(bool e,bool stock)
        {
            int i = 1;
            foreach(Producto p in productos)
            {
                if (stock)
                    Console.WriteLine("{0}) {1} '{2}' - {3} u.", i, p.tipoProducto, p.marca, p.cantidad);
                else
                {
                    if (e)
                        Console.WriteLine("{0}) {1} '{2}' ({3} - Stock: {6}) - ${4:0.00} [{5}]", i, p.tipoProducto, p.marca, p.envase, p.precio, p.fecha, p.cantidad);
                    else
                        Console.WriteLine("{0}) {1} '{2}' ({3}) - Stock: {4} [${5:0.00}]", i, p.tipoProducto, p.marca, p.envase, p.cantidad,p.precio);
                }
                i++;
            }

            return i;
        }

        public decimal TotalPagoPromo(ArrayList producto, ArrayList cantidad, int ultimo)
        {
            decimal total = 0;
            if (ultimo >= 0)
            {
                Producto p = (Producto)producto[ultimo];
                if (promociones.Count > 0)
                {
                    foreach (Promocion promo in promociones)
                    {
                        if (promo.producto == p)
                        {
                            int cantPromociones = (int)cantidad[producto.IndexOf(p)] / promo.cantProducto;
                            total += cantPromociones * promo.cantPaga * p.precio;
                            if (cantPromociones * promo.cantProducto != (int)cantidad[producto.IndexOf(p)])
                                total += ((int)cantidad[producto.IndexOf(p)] - cantPromociones * promo.cantProducto) * p.precio;
                        }
                        else
                            total += p.precio * (int)cantidad[producto.IndexOf(p)];
                    }
                } else
                    total += p.precio * (int)cantidad[producto.IndexOf(p)];
                if (ultimo == 0)
                    return total;
                else
                    return total + TotalPagoPromo(producto, cantidad, ultimo - 1);
            }
            else
                return 0;
        }
        public decimal TotalPago(ArrayList producto, ArrayList cantidad, int ultimo)
        {
            decimal total = 0;
            if (ultimo >= 0)
            {
                Producto p = (Producto)producto[ultimo];
                total += p.precio * (int)cantidad[producto.IndexOf(p)];
                if (ultimo == 0)
                    return total;
                else
                    return total + TotalPago(producto, cantidad, ultimo - 1);
            }
            else
                return 0;
        }
        public decimal PagarCarro(bool tipo)
        {
            decimal total = 0;
            if(tipo)
                total = TotalPagoPromo(carroCompra.productos, carroCompra.cantidad, carroCompra.cantidad.Count - 1);
            else
                total = TotalPago(carroCompra.productos, carroCompra.cantidad, carroCompra.cantidad.Count - 1);
            return total;
        }
        public int CantidadProductoCarro()
        {
            return carroCompra.productos.Count;
        }
        public void MostrarCarro()
        {
            for(int i = 0; i < carroCompra.productos.Count; i++)
            {
                Producto p = (Producto)carroCompra.productos[i];
                Console.WriteLine("{0} '{1}' ({2}) - {3} unidad/es", p.tipoProducto, p.marca, p.envase, carroCompra.cantidad[i]);
            }
        }
        public void AgregarACarro(Producto p, int cantidad)
        {
            bool estado = true;
            int i = 0;
            for (i = 0; i < carroCompra.productos.Count && estado; i++)
            {
                Producto pLista = (Producto)carroCompra.productos[i];

                if (pLista == p)
                    estado = false;
            }

            if (estado)
            {
                carroCompra.productos.Add(p);
                carroCompra.cantidad.Add(cantidad);
            }
            else
            {
                i--;
                carroCompra.cantidad[i] = (int)carroCompra.cantidad[i] + cantidad;
            }

        }
        public void LimpiarCarro()
        {
            carroCompra.productos.Clear();
            carroCompra.cantidad.Clear();
        }
    }
}
