﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TrabajoFinal
{
    class Mercado
    {
        public string nombre, direccion;
        public ArrayList clientes;
        public Administracion adm;

        public Mercado(string n, string d, int c)
        {
            nombre = n;
            direccion = d;
            clientes = new ArrayList();
            adm = new Administracion(c);
        }

        public bool BuscarCliente(int dni)
        {
            foreach(Cliente c in clientes)
            {
                if (c.DNI == dni)
                    return true;
            }
            return false;
        }
        public string TrearCliente(int dni)
        {
            foreach (Cliente c in clientes)
            {
                if (c.DNI == dni)
                    return c.nombre+" "+c.apellido;
            }
            return "";
        }
        public void AltaCliente(string nombre, string apellido, int dni, DateTime fecha)
        {
            Cliente c = new Cliente(nombre, apellido, dni, fecha);
            clientes.Add(c);
        }
        public void AltaCompra(int dni, Carro carro, Caja caja, DateTime fecha, decimal total, decimal totalSinPromo)
        {
            foreach(Cliente c in clientes)
            {
                if(c.DNI == dni)
                {
                    Compra compra = new Compra(caja, caja.cajero, carro, c, fecha, total, totalSinPromo);
                    adm.compras.Add(compra);

                    for (int i = 0; i < carro.productos.Count; i++)
                    {
                        foreach(Producto p in adm.productos)
                        {
                            if(p == (Producto)carro.productos[i])
                                p.cantidad -= (int)carro.cantidad[i];
                        }
                    }
                    
                }
            }
        }
        public decimal Ahorro(int dni)
        {
            decimal total = 0;
            foreach (Cliente c in clientes)
            {
                if (c.DNI == dni)
                {
                    foreach(Compra compra in adm.compras)
                    {
                        if (c == compra.cliente)
                            total += compra.totalSinPromo;
                    }
                }
            }
            return total;
        }

        public decimal TotalRecaudadoCliente(Cliente cj, ArrayList c, int ultimo)
        {
            if (ultimo >= 0)
            {
                Compra cm = (Compra)c[ultimo];
                if (cm.cliente == cj)
                {
                    if (ultimo == 0)
                        return cm.total;
                    else
                        return cm.total + TotalRecaudadoCliente(cj, c, ultimo - 1);
                }
                else
                    return TotalRecaudadoCliente(cj, c, ultimo - 1);
            }
            else
                return 0;
        }
        public void TotalRecaudadoCliente()
        {
            Console.WriteLine("\n\nTotal Recaudado en el supermercado discriminado por cliente:");
            foreach(Cliente c in clientes)
                Console.WriteLine("{0} {1}: {2} pesos", c.nombre, c.apellido, TotalRecaudadoCliente(c, adm.compras, adm.compras.Count - 1));
        }
    }
}
